/*
	Routines and data for disk kind table.

	Each kind describes the parameters for a particular kind
	of disk.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <assert.h>

#include "helios.h"
#include "helios_raw.h"
#include "disk_kind.h"

struct disk_kind kind_table [] = {
	{ "helios", 77, 32, 16, &fm_decode_bit },
	{ "dg6030", 77, 32, 8, &dg_fm_decode_bit },
	{ 0 }
};

struct disk_kind *kind = NULL;

//	Getter for current disk kind

int set_disk_kind(char *s) {
	for(kind = &kind_table[0]; kind -> name != 0; ++kind) {
		if(strcmp(s,kind -> name) == 0) {
			return(1);
		}
	}
	return(0);
}


//	Setter for disk kind

struct disk_kind *get_disk_kind() {
	if(kind) {
		return kind;
	}
	fprintf(stderr,"Error: get_disk_kind: not set.  Aborting.\n");
	exit(4);
}


//	List valid disk kinds to stderr

void list_disk_kinds() {
	struct disk_kind *k;

	fprintf(stderr,"Valid disk kinds: \n");
	for(k = &kind_table[0]; k->name != 0; ++k) {
		
		fprintf(stderr,
		    "%s: Tracks: %d, Hard Sectors: %d, Sectors: %d\n",
		    k->name, k->tracks, k->hard_sectors, k->sectors);
	}
}
