/*
	disk_kind:  Type which handles table of different kinds of
	disks.
*/

#ifndef _DISK_KIND_H_
#define _DISK_KIND_H_

#include "helios.h"

//	Disk kind table -- describes each kind of disk

struct disk_kind {
	char *name;		// Name of a kind of disk.
	int tracks;		// Tracks per disk
	int hard_sectors;	// Hard sectors per track
	int sectors;		// Soft / logical sectors per track
	void (*decode_function)();  // Address of track decode function.
};

//	Routine to set global disk kind from name.

int set_disk_kind(char *s);

//	Routine to retrieve a pointer to the disk kind entry.

struct disk_kind *get_disk_kind();

//	Routine to list the disk kinds to stderr.

void list_disk_kinds();

#endif // _DISK_KIND_H_
